#!/usr/bin/env python
# -*- coding: UTF-8 -*-
# Copyright 2014
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.


import urllib,urllib2,re,xbmcplugin,xbmcgui,xbmc,xbmcaddon,HTMLParser,sys
import shelve
from grooveshark import Client
from tools import *
from xbmcgui import ListItem
from BeautifulSoup import BeautifulSoup

versao = '0.0.8'
addon_id = 'plugin.audio.grooveshark1'
selfAddon = xbmcaddon.Addon(id=addon_id)
addonfolder = selfAddon.getAddonInfo('path')
artfolder = addonfolder + '/resources/img/'
fanart = addonfolder + '/fanart.jpg'
shelve = addonfolder + '/shelve'


def Menu_Principal():
	addDir('Buscar por Album...','-',1,artfolder + 'album.png')
	addDir('Buscar por PlayList...','-',2,artfolder + 'playlist.png')
	addDir('Buscar por Musicas...','-',3,artfolder + 'song.png')
	

def Busca_album():
	albums = []
	
	keyb = xbmc.Keyboard('', 'Digite o texto, a pesquisar.')
	keyb.doModal()
	if (keyb.isConfirmed()):
		progress = xbmcgui.DialogProgress()
		progress.create("GrooveShark1", "Buscando...")
		progress.update(0)
		cliente = Client()
		cliente.init()
		progress.update(35)
		query = keyb.getText()
		albums_ = cliente.search(query, type=cliente.ALBUMS)
		for album_ in albums_:
			albums.append(album_)
		progress.update(100)
	total = len(albums)
	#for album_ in albums:
	#	addDir(html_replace_clean(album_.name.encode('ascii', 'xmlcharrefreplace')),str(albums.index(album_)),2,'',True,total,'')
	albums_name = []
	for album_ in albums:
		albums_name.append(album_.name)
	if albums:
		index = xbmcgui.Dialog().select('Selecione o Album:', albums_name)
		if index > -1:
			progress = xbmcgui.DialogProgress()
			progress.create("GrooveShark1", "Gerando a playlist...")
			progress.update(0)
			playlist = xbmc.PlayList(1)
			playlist.clear()
			porcent = 0
			for musica_ in albums[index].songs:
				liz=xbmcgui.ListItem(musica_.name, iconImage='', thumbnailImage='')
				liz.setInfo('music', {'Title':musica_.name,'Album':'','Artist':'','Year':''})
				liz.setProperty('mimetype', 'audio/mpeg')
				playlist.add(musica_.stream.url, liz)
				porcent += 1
				progress.update(porcent,"Adcionando a musica: " + musica_.name)
				print musica_.id
				if progress.iscanceled():
					return
				if len(playlist) == 2:
					xbmcPlayer = xbmc.Player(xbmc.PLAYER_CORE_AUTO)
					xbmcPlayer.play(playlist)
			progress.update(100)


def Busca_playlist():
	albums = []
	
	keyb = xbmc.Keyboard('', 'Digite o texto, a pesquisar.')
	keyb.doModal()
	if (keyb.isConfirmed()):
		progress = xbmcgui.DialogProgress()
		progress.create("GrooveShark1", "Buscando...")
		progress.update(0)
		cliente = Client()
		cliente.init()
		progress.update(35)
		query = keyb.getText()
		albums_ = cliente.search(query, type=cliente.PLAYLISTS)
		for album_ in albums_:
			albums.append(album_)
		progress.update(100)
	total = len(albums)
	#for album_ in albums:
	#	addDir(html_replace_clean(album_.name.encode('ascii', 'xmlcharrefreplace')),str(albums.index(album_)),2,'',True,total,'')
	albums_name = []
	for album_ in albums:
		albums_name.append(album_.name)
	if albums:
		index = xbmcgui.Dialog().select('Selecione o Album:', albums_name)
		if index > -1:
			progress = xbmcgui.DialogProgress()
			progress.create("GrooveShark1", "Gerando a playlist...")
			progress.update(0)
			playlist = xbmc.PlayList(1)
			playlist.clear()
			porcent = 0
			for musica_ in albums[index].songs:
				liz=xbmcgui.ListItem(musica_.name, iconImage='', thumbnailImage='')
				liz.setInfo('music', {'Title':musica_.name,'Album':'','Artist':'','Year':''})
				liz.setProperty('mimetype', 'audio/mpeg')
				playlist.add(musica_.stream.url, liz)
				porcent += 1
				progress.update(porcent,"Adcionando a musica: " + musica_.name)
				if progress.iscanceled():
					return
				if len(playlist) == 2:
					xbmcPlayer = xbmc.Player(xbmc.PLAYER_CORE_AUTO)
					xbmcPlayer.play(playlist)
			progress.update(100)

	
def Busca_song():
	albums = []
	
	keyb = xbmc.Keyboard('', 'Digite o texto, a pesquisar.')
	keyb.doModal()
	if (keyb.isConfirmed()):
		progress = xbmcgui.DialogProgress()
		progress.create("GrooveShark1", "Buscando...")
		progress.update(0)
		cliente = Client()
		cliente.init()
		progress.update(35)
		query = keyb.getText()
		albums_ = cliente.search(query, type=cliente.SONGS)
		for album_ in albums_:
			albums.append(album_)
		progress.update(100)
	total = len(albums)
	#for album_ in albums:
	#	addDir(html_replace_clean(album_.name.encode('ascii', 'xmlcharrefreplace')),str(albums.index(album_)),2,'',True,total,'')
	albums_name = []
	for album_ in albums:
		albums_name.append(album_.name)
	if albums:
		index = xbmcgui.Dialog().select('Selecione a Musica:', albums_name)
		if index > -1:
			progress = xbmcgui.DialogProgress()
			progress.create("GrooveShark1", "Gerando a playlist...")
			progress.update(0)
			playlist = xbmc.PlayList(1)
			playlist.clear()
			porcent = 0
			musica_ = albums[index]
			liz=xbmcgui.ListItem(musica_.name, iconImage='', thumbnailImage='')
			liz.setInfo('music', {'Title':musica_.name,'Album':'','Artist':'','Year':''})
			liz.setProperty('mimetype', 'audio/mpeg')
			playlist.add(musica_.stream.url, liz)
			porcent += 1
			progress.update(porcent,"Adcionando a musica: " + musica_.name)
			if progress.iscanceled():
				return
			progress.update(100)
			xbmcPlayer = xbmc.Player(xbmc.PLAYER_CORE_AUTO)
			xbmcPlayer.play(playlist)

def Play_album(url):
	
	print inits.albums
	print url
	album_ = inits.albums[int(url)]
	progress = xbmcgui.DialogProgress()
	progress.create("PlayCds", "Gerando a playlist...")
	progress.update(0)
	playlist = xbmc.PlayList(1)
	playlist.clear()
	for musica_ in album_.songs:
		liz=xbmcgui.ListItem(musica_.name, iconImage='', thumbnailImage='')
		liz.setInfo('music', {'Title':musica_.name,'Album':'','Artist':'','Year':''})
		liz.setProperty('mimetype', 'audio/mpeg')
		playlist.add(musica_.stream.url, liz)
		progress_ = len(playlist) / float(len(musicas)) * 100
		progress.update(int(progress_))

		if progress.iscanceled():
			return
		if len(playlist) == 2:
			xbmcPlayer = xbmc.Player(xbmc.PLAYER_CORE_AUTO)
			xbmcPlayer.play(playlist)



################################################
#    Funções relacionadas a media.             #
#                                              #
################################################

def addLink(name,url,iconimage):
	ok=True
	liz=xbmcgui.ListItem(name, iconImage="DefaultVideo.png", thumbnailImage=iconimage)
	liz.setProperty('fanart_image', fanart)
	liz.setInfo( type="Video", infoLabels={ "Title": name } )
	ok=xbmcplugin.addDirectoryItem(handle=int(sys.argv[1]),url=url,listitem=liz)
	return ok

def addDir(name,url,mode,iconimage,pasta=False,total=1,plot=''):
	u=sys.argv[0]+"?url="+urllib.quote_plus(url)+"&mode="+str(mode)+"&name="+urllib.quote_plus(name)
	ok=True
	liz=xbmcgui.ListItem(name, iconImage="DefaultFolder.png", thumbnailImage=iconimage)
	liz.setProperty('fanart_image', fanart)
	liz.setInfo( type="video", infoLabels={ "title": name, "plot": plot } )
	ok=xbmcplugin.addDirectoryItem(handle=int(sys.argv[1]),url=u,listitem=liz,isFolder=pasta,totalItems=total)
	return ok



################################################
#    Pega os parametros                        #
#                                              #
################################################

def get_params():
        param=[]
        paramstring=sys.argv[2]
        if len(paramstring)>=2:
                params=sys.argv[2]
                cleanedparams=params.replace('?','')
                if (params[len(params)-1]=='/'):
                        params=params[0:len(params)-2]
                pairsofparams=cleanedparams.split('&')
                param={}
                for i in range(len(pairsofparams)):
                        splitparams={}
                        splitparams=pairsofparams[i].split('=')
                        if (len(splitparams))==2:
                                param[splitparams[0]]=splitparams[1]
                                
        return param

      
params=get_params()
url=None
name=None
mode=None
iconimage=None


try:
        url=urllib.unquote_plus(params["url"])
except:
        pass
try:
        name=urllib.unquote_plus(params["name"])
except:
        pass
try:
        mode=int(params["mode"])
except:
        pass

try:        
        iconimage=urllib.unquote_plus(params["iconimage"])
except:
        pass


print "Mode: "+str(mode)
print "URL: "+str(url)
print "Name: "+str(name)
print "Iconimage: "+str(iconimage)

################################################
#    Destina para cada modo.                   #
#                                              #
################################################

if mode==None or url==None or len(url)<1:
        print "Sem mode"
        print "Inicio: Menu Principal"
        Menu_Principal()

elif mode==1:
	print "Mode: 1 - Busca por Album"
	Busca_album()
	
elif mode==2:
	print "Mode: 2 - Busca por Playlis"
	Busca_playlist()

elif mode==3:
	print "Mode: 4 - Busca por Musicas"
	Busca_song()

elif mode==6:
	print 'Mode: 6'
	listar_albums_artista(url)
	
xbmcplugin.endOfDirectory(int(sys.argv[1]))